
Ruby - Bug #20595

Corruption of encoding name string

06/26/2024 08:18 PM - peterzhu2118 (Peter Zhu)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v:  Backport: 3.1: DONTNEED, 3.2: DONTNEED, 3.3:

DONE

Description

GitHub PR: https://github.com/ruby/ruby/pull/11062

enc_set_default_encoding will free the C string if the encoding is nil, but the C string can be used by the encoding name string. This

will cause the encoding name string to be corrupted.

Consider the following code:

Encoding.default_internal = Encoding::ASCII_8BIT

names = Encoding.default_internal.names

p names

Encoding.default_internal = nil

p names

 It outputs:

["ASCII-8BIT", "BINARY", "internal"]

["ASCII-8BIT", "BINARY", "\x00\x00\x00\x00\x00\x00\x00\x00"]

Associated revisions

Revision c6a0d03649c686a537c1f513a1e32205ac6a6512 - 06/27/2024 01:47 PM - peterzhu2118 (Peter Zhu)

Fix corruption of encoding name string

[Bug #20595]

enc_set_default_encoding will free the C string if the encoding is nil,

but the C string can be used by the encoding name string. This will cause

the encoding name string to be corrupted.

Consider the following code:

Encoding.default_internal = Encoding::ASCII_8BIT

names = Encoding.default_internal.names

p names

Encoding.default_internal = nil

p names

 It outputs:

["ASCII-8BIT", "BINARY", "internal"]

["ASCII-8BIT", "BINARY", "\x00\x00\x00\x00\x00\x00\x00\x00"]

 Co-authored-by: Matthew Valentine-House matt@eightbitraptor.com

Revision c6a0d03649c686a537c1f513a1e32205ac6a6512 - 06/27/2024 01:47 PM - peterzhu2118 (Peter Zhu)

Fix corruption of encoding name string

[Bug #20595]

enc_set_default_encoding will free the C string if the encoding is nil,

but the C string can be used by the encoding name string. This will cause

the encoding name string to be corrupted.

Consider the following code:
Encoding.default_internal = Encoding::ASCII_8BIT

names = Encoding.default_internal.names

p names

Encoding.default_internal = nil

p names

 It outputs:

["ASCII-8BIT", "BINARY", "internal"]

["ASCII-8BIT", "BINARY", "\x00\x00\x00\x00\x00\x00\x00\x00"]

 Co-authored-by: Matthew Valentine-House matt@eightbitraptor.com

Revision c6a0d036 - 06/27/2024 01:47 PM - peterzhu2118 (Peter Zhu)

Fix corruption of encoding name string

[Bug #20595]

enc_set_default_encoding will free the C string if the encoding is nil,

but the C string can be used by the encoding name string. This will cause

the encoding name string to be corrupted.

Consider the following code:

Encoding.default_internal = Encoding::ASCII_8BIT

names = Encoding.default_internal.names

p names

Encoding.default_internal = nil

p names

 It outputs:

["ASCII-8BIT", "BINARY", "internal"]

["ASCII-8BIT", "BINARY", "\x00\x00\x00\x00\x00\x00\x00\x00"]

 Co-authored-by: Matthew Valentine-House matt@eightbitraptor.com

Revision 7a780a3ef766e0622ade4a5fbf2518f73c38282b - 06/27/2024 02:46 PM - peterzhu2118 (Peter Zhu)

[Bug #20595] Fix corruption of encoding name string (#11063)

Fix corruption of encoding name string

[Bug #20595]

enc_set_default_encoding will free the C string if the encoding is nil,

but the C string can be used by the encoding name string. This will cause

the encoding name string to be corrupted.

Consider the following code:

Encoding.default_internal = Encoding::ASCII_8BIT

names = Encoding.default_internal.names

p names

Encoding.default_internal = nil

p names

 It outputs:

["ASCII-8BIT", "BINARY", "internal"]

["ASCII-8BIT", "BINARY", "\x00\x00\x00\x00\x00\x00\x00\x00"]

 Co-authored-by: Matthew Valentine-House matt@eightbitraptor.com

Revision 7a780a3ef766e0622ade4a5fbf2518f73c38282b - 06/27/2024 02:46 PM - peterzhu2118 (Peter Zhu)

[Bug #20595] Fix corruption of encoding name string (#11063)

Fix corruption of encoding name string

[Bug #20595]

enc_set_default_encoding will free the C string if the encoding is nil,

but the C string can be used by the encoding name string. This will cause
the encoding name string to be corrupted.

Consider the following code:

Encoding.default_internal = Encoding::ASCII_8BIT

names = Encoding.default_internal.names

p names

Encoding.default_internal = nil

p names

 It outputs:

["ASCII-8BIT", "BINARY", "internal"]

["ASCII-8BIT", "BINARY", "\x00\x00\x00\x00\x00\x00\x00\x00"]

 Co-authored-by: Matthew Valentine-House matt@eightbitraptor.com

Revision 7a780a3e - 06/27/2024 02:46 PM - peterzhu2118 (Peter Zhu)

[Bug #20595] Fix corruption of encoding name string (#11063)

Fix corruption of encoding name string

[Bug #20595]

enc_set_default_encoding will free the C string if the encoding is nil,

but the C string can be used by the encoding name string. This will cause

the encoding name string to be corrupted.

Consider the following code:

Encoding.default_internal = Encoding::ASCII_8BIT

names = Encoding.default_internal.names

p names

Encoding.default_internal = nil

p names

 It outputs:

["ASCII-8BIT", "BINARY", "internal"]

["ASCII-8BIT", "BINARY", "\x00\x00\x00\x00\x00\x00\x00\x00"]

 Co-authored-by: Matthew Valentine-House matt@eightbitraptor.com

Revision 176c4bb3c7db87ca5b0486012cb6a005105448c5 - 06/27/2024 06:06 PM - peterzhu2118 (Peter Zhu)

Fix corruption of internal encoding string

[Bug #20598]

Just like [Bug #20595], Encoding#name_list and Encoding#aliases can have

their strings corrupted when Encoding.default_internal is set to nil.

Co-authored-by: Matthew Valentine-House matt@eightbitraptor.com

Revision 176c4bb3c7db87ca5b0486012cb6a005105448c5 - 06/27/2024 06:06 PM - peterzhu2118 (Peter Zhu)

Fix corruption of internal encoding string

[Bug #20598]

Just like [Bug #20595], Encoding#name_list and Encoding#aliases can have

their strings corrupted when Encoding.default_internal is set to nil.

Co-authored-by: Matthew Valentine-House matt@eightbitraptor.com

Revision 176c4bb3 - 06/27/2024 06:06 PM - peterzhu2118 (Peter Zhu)

Fix corruption of internal encoding string

[Bug #20598]

Just like [Bug #20595], Encoding#name_list and Encoding#aliases can have

their strings corrupted when Encoding.default_internal is set to nil.
Co-authored-by: Matthew Valentine-House matt@eightbitraptor.com

Revision 291cc913503475a204c93a53a2f470c8cc6bfca2 - 06/28/2024 08:04 PM - peterzhu2118 (Peter Zhu)

[Bug #20598] Fix corruption of internal encoding string (#11069)

Fix corruption of internal encoding string

[Bug #20598]

Just like [Bug #20595], Encoding#name_list and Encoding#aliases can have

their strings corrupted when Encoding.default_internal is set to nil.

Co-authored-by: Matthew Valentine-House matt@eightbitraptor.com

Revision 291cc913503475a204c93a53a2f470c8cc6bfca2 - 06/28/2024 08:04 PM - peterzhu2118 (Peter Zhu)

[Bug #20598] Fix corruption of internal encoding string (#11069)

Fix corruption of internal encoding string

[Bug #20598]

Just like [Bug #20595], Encoding#name_list and Encoding#aliases can have

their strings corrupted when Encoding.default_internal is set to nil.

Co-authored-by: Matthew Valentine-House matt@eightbitraptor.com

Revision 291cc913 - 06/28/2024 08:04 PM - peterzhu2118 (Peter Zhu)

[Bug #20598] Fix corruption of internal encoding string (#11069)

Fix corruption of internal encoding string

[Bug #20598]

Just like [Bug #20595], Encoding#name_list and Encoding#aliases can have

their strings corrupted when Encoding.default_internal is set to nil.

Co-authored-by: Matthew Valentine-House matt@eightbitraptor.com

History

#1 - 06/26/2024 08:25 PM - peterzhu2118 (Peter Zhu)

The Ruby 3.3 backport PR is here: https://github.com/ruby/ruby/pull/11063

#2 - 06/27/2024 01:47 PM - peterzhu2118 (Peter Zhu)

- Status changed from Open to Closed

Applied in changeset git|c6a0d03649c686a537c1f513a1e32205ac6a6512.

Fix corruption of encoding name string

[Bug #20595]

enc_set_default_encoding will free the C string if the encoding is nil,

but the C string can be used by the encoding name string. This will cause

the encoding name string to be corrupted.

Consider the following code:

Encoding.default_internal = Encoding::ASCII_8BIT

names = Encoding.default_internal.names

p names

Encoding.default_internal = nil

p names

 It outputs:

["ASCII-8BIT", "BINARY", "internal"]

["ASCII-8BIT", "BINARY", "\x00\x00\x00\x00\x00\x00\x00\x00"]
 Co-authored-by: Matthew Valentine-House matt@eightbitraptor.com

#3 - 07/08/2024 10:56 PM - k0kubun (Takashi Kokubun)

- Backport changed from 3.1: DONTNEED, 3.2: DONTNEED, 3.3: REQUIRED to 3.1: DONTNEED, 3.2: DONTNEED, 3.3: DONE

ruby_3_3 291cc913503475a204c93a53a2f470c8cc6bfca2.
